<template>
  <div class="app-container">


    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:warehouse-area:create']">新增库域</el-button>

        <el-button type="primary" plain size="mini" @click="positionManager"
                   >仓位管理</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list" row-key="id" default-expand-all :tree-props="{children: 'children', hasChildren: 'hasChildren'}">
      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="代码" align="center" prop="code" />
      <el-table-column label="类型" align="center" prop="pid">
        <template slot-scope="scope">
          <span>{{ scope.row.pid == 0 ? '库域' : '库区' }}</span>
         </template>
      </el-table-column>
      
      <el-table-column label="仓库" align="center" prop="warehouse" width="180">
         <template slot-scope="scope">
          <span>{{ warehouseName(scope.row.warehouseId) }}</span>
         </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:warehouse-area:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:warehouse-area:delete']">删除</el-button>
          <el-button size="mini" type="text"  @click="handleCreate(scope.row)" v-if="scope.row.pid==0"
                     v-hasPermi="['ecw:warehouse-area:create']">添加库区</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="上级库域" prop="parentName" v-if="parentDo">
            <span>{{parentDo.name}}</span>
        </el-form-item>

        <el-form-item label="类型" prop="parentType" v-if="parentDo">
            <span>库区</span>
        </el-form-item>

        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="代码" prop="code">
          <el-input v-model="form.code" placeholder="请输入代码" />
        </el-form-item>
        <el-form-item label="仓库" prop="warehouseId">
          <el-select v-model="form.warehouseId" clearable :disabled="parentDo">
            <el-option v-for="warehouse in warehouseList" :key="warehouse.id" :label="warehouse.titleZh" :value="warehouse.id" /> 
          </el-select>
        </el-form-item>  
        
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { createWarehouseArea, updateWarehouseArea, deleteWarehouseArea, getWarehouseArea, getWarehouseAreaPage, exportWarehouseAreaExcel } from "@/api/ecw/warehouseArea";
import { getWarehouseList } from "@/api/ecw/warehouse"
export default {
  name: "WarehouseArea",
  components: {
  },
  data() {
    return {
      //仓库列表
      warehouseList: [],
      parentDo:null,

      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 库区库域列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        warehouseId: null,
        name: null,
        code: null,
        pid: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [{ required: true, message: "名称不能为空", trigger: "blur" }],
      }
    };
  },

  computed: {
    warehouseName() {
      return warehouseId => {
        for(let index in this.warehouseList) {
          let warehouseItem = this.warehouseList[index];
          if(warehouseItem.id == warehouseId) {
            return warehouseItem.titleZh;
          }
        }
      }
    },
  },

  created() {
    this.requestWarehouseList();
    this.getList();
  },
  methods: {
    positionManager() {
        this.$router.push('/warehouse/warehouse-area-position');
    },

    /**查询仓库 */
    requestWarehouseList() {
      getWarehouseList({}).then(response => {
        this.warehouseList = response.data;
      })
    },

    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getWarehouseAreaPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.parentDo = null;
      this.form = {
        id: undefined,
        warehouseId: undefined,
        name: undefined,
        code: undefined,
        pid: undefined,
        status: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加库区库域";
    },

    /**  新增库区 */
    handleCreate(row) {
      this.reset();
      this.parentDo = row;
      this.form.warehouseId = row.warehouseId;
      this.form.pid = row.id;
      this.open = true;
      this.title = "添加库区库域";
    },

    findParent(pid) {
      for(let index in this.list) {
        let row = this.list[index];
        if(row.id == pid) return row;
      }
    },

    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getWarehouseArea(id).then(response => {
        this.form = response.data;

        if(this.form.pid > 0) {
          this.parentDo = this.findParent(this.form.pid);
        }

        this.open = true;
        this.title = "修改库区库域";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateWarehouseArea(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createWarehouseArea(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除库区库域编号为"' + id + '"的数据项?').then(function() {
          return deleteWarehouseArea(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有库区库域数据项?').then(() => {
          this.exportLoading = true;
          return exportWarehouseAreaExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
